from django.shortcuts import render
from django.http import HttpResponse
from locator.models import Coordinates
from django.contrib.sessions.backends.db import SessionStore

import sys
import json
import geopy
from geopy.distance import vincenty

def home(req):

    tmpl_vars = {
        'all_locations': Coordinates.objects.reverse(),
    }
    return render(req, 'locator/index.html', tmpl_vars)

def delete_user(request):
    if request.method == 'POST':
        user = request.POST.get('username')

        response_data = {}

        response_data['result'] = 'User deleted'
        response_data['username'] = user

       
        if Coordinates.objects.filter(username=user).exists():
            Coordinates.objects.filter(username=user).delete()

        return HttpResponse(
                            json.dumps(response_data),
                            content_type="application/json"
                            )

def find_closest(c1):
    min_dist = 10000
    min_user = ""
    for c2 in Coordinates.objects.all():
        if c1.username != c2.username:
            dist = vincenty((c1.latitude, c1.longitude),(c2.latitude,c2.longitude))
            if dist < min_dist:
                min_dist = dist
                min_user = c2.username
    return min_user



def update_location(request):
    if request.method == 'POST':
        lat = request.POST.get('lat')
        lon = request.POST.get('lon')
	user = request.POST.get('username')

        response_data = {}

        if Coordinates.objects.filter(username=user).exists(): #existing user
            location = Coordinates.objects.filter(username=user)[0]
            location.latitude = float(str(lat))
            location.longitude = float(str(lon))
            closest = find_closest(location)
            location.closest_user = closest
            location.save()

            response_data['result'] = 'Location updated existing user ' + user
            response_data['username'] = user
            response_data['closest_user'] = closest
            response_data['locationpk'] = location.pk
            response_data['latitude'] = location.latitude
            response_data['longitude'] = location.longitude
            response_data['created'] = location.created.strftime('%B %d, %Y %I:%M:%S %p')
            response_data['updated'] = location.created.strftime('%B %d, %Y %I:%M:%S %p')
            response_data['broadcasting'] = location.broadcasting

        else: #new user

            location = Coordinates(latitude=float(str(lat)), longitude=float(str(lon)), username=user)
            location.save()

            closest = find_closest(location)
            location.closest_user = closest
            location.save()


            response_data['result'] = 'New user logged ' + user
            response_data['username'] = user
            response_data['closest_user'] = closest
            response_data['locationpk'] = location.pk
            response_data['latitude'] = location.latitude
            response_data['longitude'] = location.longitude
            response_data['created'] = location.created.strftime('%B %d, %Y %I:%M:%S %p')
            response_data['updated'] = location.updated.strftime('%B %d, %Y %I:%M:%S %p')
            response_data['broadcasting'] = location.broadcasting

        return HttpResponse(
                            json.dumps(response_data),
                            content_type="application/json"
                            )
    else:
        return HttpResponse(
                            json.dumps({"nothing to see": "this isn't happening"}),
                            content_type="application/json"
                            )

