$(function() {

// nothing

console.log("nothing")

});

var interval;
var refresh_interval;

// This function gets cookie with a given name
function getCookie(name) {
    var cookieValue = null;
    if (document.cookie && document.cookie != '') {
        var cookies = document.cookie.split(';');
        for (var i = 0; i < cookies.length; i++) {
            var cookie = jQuery.trim(cookies[i]);
            // Does this cookie string begin with the name we want?
            if (cookie.substring(0, name.length + 1) == (name + '=')) {
                cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                break;
            }
        }
    }
    return cookieValue;
}
var csrftoken = getCookie('csrftoken');

/*
The functions below will create a header with csrftoken
*/

function csrfSafeMethod(method) {
    // these HTTP methods do not require CSRF protection
    return (/^(GET|HEAD|OPTIONS|TRACE)$/.test(method));
}
function sameOrigin(url) {
    // test that a given url is a same-origin URL
    // url could be relative or scheme relative or absolute
    var host = document.location.host; // host + port
    var protocol = document.location.protocol;
    var sr_origin = '//' + host;
    var origin = protocol + sr_origin;
    // Allow absolute or scheme relative URLs to same origin
    return (url == origin || url.slice(0, origin.length + 1) == origin + '/') ||
        (url == sr_origin || url.slice(0, sr_origin.length + 1) == sr_origin + '/') ||
        // or any other URL that isn't scheme relative or absolute i.e relative.
        !(/^(\/\/|http:|https:).*/.test(url));
}

function start_tracking() {
    request_location();
    interval = setInterval(request_location, 15000);
    

}

function stop_tracking() {
    clearInterval(interval);
    $.ajax({
        url : "delete_user/",
        type : "POST",
        data: {username : $('#username-input').val()},

        // handle a successful response
        success : function(json) {
            console.log($('#username-input').val() + " deleted."); // another sanity check
            update_user_list();

        },

        error : function(xhr,errmsg,err) {
            $('#results').html("<div class='alert-box alert radius' data-alert>Oops! We have encountered an error: "+errmsg+
            " <a href='#' class='close'>&times;</a></div>"); // add the error to the dom
            console.log(xhr.status + ": " + xhr.responseText); // provide a bit more info about the error to the console
        }
    });
}

function request_location() {
    console.log("Requesting location...");
    if (navigator.geolocation) {
        navigator.geolocation.getCurrentPosition(update_GPS_location);
    } else {
        console.log("Geolocation is not supported by this browser.");
    }
}

function update_GPS_location(position) {
    console.log("GPS location is working!") // sanity check
    console.log($('#username-input').val())
    var gps_lat = position.coords.latitude;
    var gps_lon = position.coords.longitude;
    $.ajax({
        url : "update_location/",
        type : "POST",
        data: { lat : gps_lat, lon : gps_lon, username : $('#username-input').val(), broadcasting: "True"},

        // handle a successful response
        success : function(json) {
            console.log(json); // log the returned json to the console
            update_user_list();
            console.log("Location updated! "+gps_lat+", "+gps_lon); // another sanity check

        },

        error : function(xhr,errmsg,err) {
            $('#results').html("<div class='alert-box alert radius' data-alert>Oops! We have encountered an error: "+errmsg+
            " <a href='#' class='close'>&times;</a></div>"); // add the error to the dom
            console.log(xhr.status + ": " + xhr.responseText); // provide a bit more info about the error to the console
        }
    });
};

function interval_refresh() {
    refresh_interval = setInterval(update_user_list, 7000)    
}


function update_user_list() {
    $('#locations').load(document.URL +  ' #locations');
}

$.ajaxSetup({
    beforeSend: function(xhr, settings) {
        if (!csrfSafeMethod(settings.type) && sameOrigin(settings.url)) {
            // Send the token to same-origin, relative URLs only.
            // Send the token only if the method warrants CSRF protection
            // Using the CSRFToken value acquired earlier
            xhr.setRequestHeader("X-CSRFToken", csrftoken);
        }
    }
});
